jQuery(function ($) {
  $("select#csca_remove_state1").change(function () {
    var state = $(this).val();
    if (state == "0") {
      $("#csca_remove_city").html('<option value="0">Select City</option>');
      return false;
    }
    jQuery.ajax({
      url: tc_csca_admin_ajax.ajax_url,
      type: "post",
      dataType: "html",
      data: {
        action: "tc_csca_admin_get_cities",
        nonce_ajax: tc_csca_admin_ajax.nonce,
        sid: state,
      },
      success: function (response) {
        //console.log(response);
        var res = JSON.parse(response);
        if (res.length > 0) {
          $("#csca_remove_city").html("");
          for (i = 0; i < res.length; i++) {
            var ct_id = res[i].id;
            var ct_name = res[i].name;
            var st_id = res[i].state_id;
            var opt = "<option value='" + ct_id + "'>" + ct_name + "</option>";
            $("#csca_remove_city").append(opt);
          }
        } else {
          $("#csca_remove_city").html("<option>City List Not Found</option>");
        }
      },
    });
  });

  $("#csca_country1").change(function () {
    var country = $(this).val();
    if (country == "0") {
      $("#csca_remove_state").html('<option value="0">Select State</option>');
      return false;
    }
    jQuery.ajax({
      url: tc_csca_admin_ajax.ajax_url,
      type: "post",
      dataType: "html",
      data: {
        action: "tc_csca_admin_get_states",
        nonce_ajax: tc_csca_admin_ajax.nonce,
        cid: country,
      },
      success: function (response) {
        //console.log(response);
        var res = JSON.parse(response);
        if (res.length > 0) {
          $(".st_get_ajax").html("");
          for (i = 0; i < res.length; i++) {
            var st_id = res[i].id;
            var st_name = res[i].name;
            var opt = "<option value='" + st_id + "'>" + st_name + "</option>";
            $(".st_get_ajax").append(opt);
          }
        } else {
          $(".st_get_ajax").html("<option>State List Not Found</option>");
        }
      },
    });
  });
});

/* Patch Update Js*/
jQuery(function ($) {
  infoTip("select#patch");
  function infoTip(div) {
    var tip = $(div).find("option:selected").attr('data-tip');
    $(".select-info-tip").html(tip);
  }
  $("select#patch").change(function () {
    infoTip($(this));
  });
  $("#update-patch").click(function (e) {
    var optval = $("#patch").val();
    var cnt = $("#patch").find("option:selected").attr('data-country');
    var newattr = $("#patch").find("option:selected").attr('new-attr');
    jQuery.ajax({
      url: tc_csca_admin_ajax.ajax_url,
      type: 'post',
      dataType: "json",
      data: {
        action: "tc_csca_patch_settings",
        nonce_ajax: tc_csca_admin_ajax.nonce,
        value: optval, country: cnt , newatt:newattr,
      },
      success: function (response) {
        console.log(response);
        if (response.message) {
          if ($(".tc_response_update").length > 0) {
            $(".tc_response_update").remove();
          }
          $(".patch-button").append("<div class='tc_response_update'>" + response.message + "</div>");
          setTimeout(function () { $(".tc_response_update").fadeOut().remove(); }, 5000)
        }
      }
    });
  });
});  
