<?php
if ( ! defined( 'ABSPATH' ) ) {
    exit; // Exit if accessed directly
}
add_action('wp_ajax_tc_pro_csca_get_countries', 'tc_pro_csca_get_countries');
add_action("wp_ajax_nopriv_tc_pro_csca_get_countries", "tc_pro_csca_get_countries");

function tc_pro_csca_get_countries()
{
    check_ajax_referer('tc_pro_csca_ajax_nonce', 'nonce_ajax');
    if (get_option('csca_options')) {
        $other_info = get_option('csca_options');
        if (isset($other_info['csca_select_country_by_IP_others'])) {$csca_select_country_by_IP = $other_info['csca_select_country_by_IP_others'];
            if ($csca_select_country_by_IP == '0') {
                $csca_default_country = $other_info['csca_default_country_others'];
            } else if ($csca_select_country_by_IP == '1' || $csca_select_country_by_IP == true) {
                $csca_default_country_name = strtolower(ip_info("Visitor", "Country"));
                //$csca_default_country_name='india';
                if ($csca_default_country_name) {
                    $cnt = get_countries();
                    foreach ($cnt as $key => $cntr) {
                        $cntr1 = strtolower($cntr->name);
                        if ($cntr1 == $csca_default_country_name) {
                            $csca_default_country = $cntr->id;
                        }
                    }
                }
            } else {
                $csca_default_country = '1';
            }
        }
        if (isset($other_info['csca_selected_countries_others'])) {
            $csca_selected_countries = $other_info['csca_selected_countries_others'];
            $results['countries'] = get_country_name_by_ids($csca_selected_countries);
        } else {
            $results['countries'] = get_countries();
        }
    } else {
        $country_id = '0';
        $state_id = '0';
        $city_id = '0';
        $country_place = 'Select Country';
        $state_place = 'Select State';
        $city_place = 'Select City';
        $csca_selected_countries = array();

    }
    $csca_default_country = $other_info['csca_default_country_others'];
    if ($csca_default_country) {
        $states = get_states_by_country_id($csca_default_country);
    } else {
        $states = array();
    }
    $csca_selected_countries = array();
    $data = array('select_specific' => $csca_selected_countries, 'default_country' => $csca_default_country);
    $results['data'] = $data;
    $results['states'] = $states;
    echo json_encode($results);
    wp_die();
}

add_action('wp_ajax_tc_csca_admin_get_cities', 'tc_csca_admin_get_cities');
add_action("wp_ajax_nopriv_tc_csca_admin_get_cities", "tc_csca_admin_get_cities");

function tc_csca_admin_get_cities()
{
    if (isset($_POST["sid"])) {
        $sid = sanitize_text_field($_POST["sid"]);
        check_ajax_referer('tc_caf_admin_ajax_nonce', 'nonce_ajax');
        $results = get_cities_by_state_id($sid);
        echo json_encode($results);
        wp_die();
    }
}

add_action('wp_ajax_tc_pro_csca_get_states', 'tc_pro_csca_get_states');
add_action("wp_ajax_nopriv_tc_pro_csca_get_states", "tc_pro_csca_get_states");
function tc_pro_csca_get_states()
{
    if (isset($_POST["cid"])) {
        $cid = sanitize_text_field($_POST["cid"]);
        check_ajax_referer('tc_pro_csca_ajax_nonce', 'nonce_ajax');
        $results = get_states_by_country_id($cid);
        echo json_encode($results);
        wp_die();
    }
}

add_action('wp_ajax_tc_pro_csca_get_cities', 'tc_pro_csca_get_cities');
add_action("wp_ajax_nopriv_tc_pro_csca_get_cities", "tc_pro_csca_get_cities");
function tc_pro_csca_get_cities()
{
    if (isset($_POST["sid"])) {
        $sid = sanitize_text_field($_POST["sid"]);
        check_ajax_referer('tc_pro_csca_ajax_nonce', 'nonce_ajax');
        $results = get_cities_by_state_id($sid);
        echo json_encode($results);
        wp_die();
    }
}

add_action('wp_ajax_tc_pro_csca_get_cities_only', 'tc_pro_csca_get_cities_only');
add_action("wp_ajax_nopriv_tc_pro_csca_get_cities_only", "tc_pro_csca_get_cities_only");
function tc_pro_csca_get_cities_only()
{
    if (isset($_POST["cid"])) {
        $cid = sanitize_text_field($_POST["cid"]);
        check_ajax_referer('tc_pro_csca_ajax_nonce', 'nonce_ajax');
        $results = get_cities_by_country_id($cid);
        //var_dump($results);
        echo json_encode($results);
        wp_die();
    }
}

add_action('wp_ajax_tc_csca_admin_get_states', 'tc_csca_admin_get_states');
add_action("wp_ajax_nopriv_tc_csca_admin_get_states", "tc_csca_admin_get_states");
function tc_csca_admin_get_states()
{
    if (isset($_POST["cid"])) {
        $cid = sanitize_text_field($_POST["cid"]);
        $states = array();
        check_ajax_referer('tc_caf_admin_ajax_nonce', 'nonce_ajax');
        $states = get_states_by_country_id($cid);
        echo json_encode($states);
    }
    wp_die();
}

                /***** START Update Patch function *****/

add_action('wp_ajax_tc_csca_patch_settings', 'tc_csca_patch_settings');
//add_action("wp_ajax_nopriv_tc_csca_patch_settings", "tc_csca_patch_settings");

function get_items_array()
{
    return $items = array("west_bengal" => array('Alipurduar', 'Bankura', 'Cooch Behar', 'Dakshin Dinajpur (South Dinajpur)', 'Darjeeling',
        'Hooghly', 'Howrah', 'Jalpaiguri', 'Jhargram', 'Kalimpong', 'Kolkata', 'Malda', 'Murshidabad', 'Nadia', 'North 24 Parganas', 'Paschim Medinipur (West Medinipur)',
        'Paschim (West) Burdwan (Bardhaman)', 'Purba Burdwan (Bardhaman)', 'Purba Medinipur (East Medinipur)', 'Purulia', 'South 24 Parganas', 'Uttar Dinajpur (North Dinajpur)'),
        "ladakh" => array('Kargil', 'Leh', 'Chuglamsar', 'Spituk'),
    );
}
function get_state_by_name($name, $table_state)
{
    global $wpdb;
    return $wpdb->get_results($wpdb->prepare("SELECT * FROM  $table_state where LOWER(name)='$name'"));
}
function update_state_name($name, $table_state){

    global $wpdb;
    return $wpdb->query($wpdb->prepare(" UPDATE $table_state SET `name` = 'Kyiv' WHERE `$table_state`.`name` = '$name'; "));
}
function get_cities_by_state_id_patch($st_id, $table_city)
{
    global $wpdb;
    return $wpdb->get_results($wpdb->prepare("SELECT name FROM  $table_city where state_id='$st_id'"));
}
function update_city_table($ct, $st_id, $table_city)
{
    global $wpdb;
    return $wpdb->query($wpdb->prepare("insert into $table_city (`name`, `state_id`) values('$ct','$st_id')"));
}
function build_qry($name, $st_id)
{
    global $wpdb;
    $table_city = $wpdb->prefix . 'city_pro';
    $values = array();
    $name = str_replace(' ', '_', $name);
    $items = get_items_array();
    $items = $items[$name];
    foreach ($items as $key => $value) {
        $values[] = $wpdb->prepare("(%s,%s)", $value, $st_id);
    }
    $query = "INSERT INTO $table_city (`name`, `state_id`) VALUES ";
    return $query .= implode(",", $values);
}
function tc_csca_patch_settings()
{
    check_ajax_referer('tc_caf_admin_ajax_nonce', 'nonce_ajax');
    global $wpdb;
    $table_state = $wpdb->prefix . 'state_pro';
    $table_cnt = $wpdb->prefix . 'countries_pro';
    $table_city = $wpdb->prefix . 'city_pro';
    $tables = array("countries_pro", "state_pro", "city_pro");

    foreach ($tables as $table) {
        $tbl = $wpdb->prefix . $table;
        $rs = $wpdb->get_results($wpdb->prepare("SHOW INDEXES FROM $tbl"));
        if (!$rs) {
            $wpdb->query("ALTER TABLE $tbl CHANGE id id mediumint(8)	AUTO_INCREMENT PRIMARY KEY");
        }
    }
    $response = [
        'status' => 200,
        'message' => 'Already Updated',
    ];

    if (isset($_POST['value'])) {   
        $name = sanitize_text_field(strtolower($_POST["value"]));
        $name1 = sanitize_text_field($_POST["value"]);
        $country = sanitize_text_field($_POST["country"]);
        $newattr = sanitize_text_field($_POST["newatt"]);
        $table_state = $wpdb->prefix . 'state_pro';
        $table_city = $wpdb->prefix . 'city_pro';
        $state_res = get_state_by_name($name, $table_state);
        if($newattr=='updateKiev'){
            $old_st_name = $state_res[0]->name;
            if($name1==$old_st_name){
            update_state_name($name1, $table_state);
            $response = [
                'status' => 200,
                'message' => 'State Name Update Successfully',
            ]; 
            }else{
                $response = [
                    'status' => 200,
                    'message' => 'State Name Already Updated',
                ];
            }
        }else{
        if (count($state_res) > 0) {
            $st_id = $state_res[0]->id;
            $cities = get_cities_by_state_id_patch($st_id, $table_city);
            //var_dump($cities);
            if ($cities) {
                $ct = [];
                foreach ($cities as $city) {
                    $ct[] = $city->name;
                }
                $st_name = str_replace(' ', '_', $name);
                $items = get_items_array();
                $items_cities = $items[$st_name];
                foreach ($items_cities as $city) {
                    if (!in_array($city, $ct)) {
                        $res = update_city_table($city, $st_id, $table_city);
                        $response = [
                            'status' => 200,
                            'message' => 'Cities updated successfully in ' . $name1,
                        ];
                    }
                }
            } else {
                $qry = build_qry($name, $st_id);
                if ($wpdb->query($qry)) {
                    $response = [
                        'status' => 200,
                        'message' => 'New Cities inserted successfully in ' . $name,
                    ];
                }
            }

        } else {
            $state_insert = $wpdb->insert($table_state, array(
                'name' => $name1,
                'country_id' => $country,
            ));
            $state_res = $wpdb->get_results($wpdb->prepare("SELECT id FROM  $table_state where LOWER(name)='$name'"));
            $st_id = $state_res[0]->id;
            $qry = build_qry($name, $st_id);
            if ($wpdb->query($qry)) {
                $response = [
                    'status' => 200,
                    'message' => 'New State (' . $name . ') and Cities inserted successfully',
                ];
            }

        }
        }
    }
    die(json_encode($response));
    // wp_die();
}

                    /***** END Update Patch function *****/