<?php
if ( ! defined( 'ABSPATH' ) ) {
    exit; // Exit if accessed directly
}
/**
 ** CSCA FUNCTIONS
 **/
function get_countries()
{
    global $wpdb;
    $tbl = 'countries_pro';
    $results = $wpdb->get_results($wpdb->prepare("SELECT * FROM " . $wpdb->base_prefix . "%1s", $tbl));
    return $results;
}

function get_country_name_by_ids($ids)
{
    $results = array();
    foreach ($ids as $id) {
        global $wpdb;
        $tbl = 'countries_pro';
        $results[] = $wpdb->get_results($wpdb->prepare("SELECT * FROM " . $wpdb->base_prefix . "%1s" . " where id='$id' order by name asc", $tbl), OBJECT);
    }
    return $results;
}

function ip_info($ip = null, $purpose = "location", $deep_detect = true)
{

    /*---- RESOURCES FOUND FROM STACKOVERFLOW ----*/
    $output = null;
    if (filter_var($ip, FILTER_VALIDATE_IP) === false) {
        $ip = $_SERVER["REMOTE_ADDR"];
        if ($deep_detect) {
            if (filter_var(@$_SERVER['HTTP_X_FORWARDED_FOR'], FILTER_VALIDATE_IP)) {
                $ip = $_SERVER['HTTP_X_FORWARDED_FOR'];
            }

            if (filter_var(@$_SERVER['HTTP_CLIENT_IP'], FILTER_VALIDATE_IP)) {
                $ip = $_SERVER['HTTP_CLIENT_IP'];
            }

        }
    }
    $purpose = str_replace(array("name", "\n", "\t", " ", "-", "_"), null, strtolower(trim($purpose)));
    $support = array("country", "countrycode", "state", "region", "city", "location", "address");
    $continents = array(
        "AF" => "Africa",
        "AN" => "Antarctica",
        "AS" => "Asia",
        "EU" => "Europe",
        "OC" => "Australia (Oceania)",
        "NA" => "North America",
        "SA" => "South America",
    );
    if (filter_var($ip, FILTER_VALIDATE_IP) && in_array($purpose, $support)) {
        $ipdat = @json_decode(file_get_contents("http://www.geoplugin.net/json.gp?ip=" . $ip));
        if (@strlen(trim($ipdat->geoplugin_countryCode)) == 2) {
            switch ($purpose) {
                case "location":
                    $output = array(
                        "city" => @$ipdat->geoplugin_city,
                        "state" => @$ipdat->geoplugin_regionName,
                        "country" => @$ipdat->geoplugin_countryName,
                        "country_code" => @$ipdat->geoplugin_countryCode,
                        "continent" => @$continents[strtoupper($ipdat->geoplugin_continentCode)],
                        "continent_code" => @$ipdat->geoplugin_continentCode,
                    );
                    break;
                case "address":
                    $address = array($ipdat->geoplugin_countryName);
                    if (@strlen($ipdat->geoplugin_regionName) >= 1) {
                        $address[] = $ipdat->geoplugin_regionName;
                    }

                    if (@strlen($ipdat->geoplugin_city) >= 1) {
                        $address[] = $ipdat->geoplugin_city;
                    }

                    $output = implode(", ", array_reverse($address));
                    break;
                case "city":
                    $output = @$ipdat->geoplugin_city;
                    break;
                case "state":
                    $output = @$ipdat->geoplugin_regionName;
                    break;
                case "region":
                    $output = @$ipdat->geoplugin_regionName;
                    break;
                case "country":
                    $output = @$ipdat->geoplugin_countryName;
                    break;
                case "countrycode":
                    $output = @$ipdat->geoplugin_countryCode;
                    break;
            }
        }
    }
    return $output;
}

function get_states_by_country_id($csca_default_country)
{
    global $wpdb;
    $tbl = 'state_pro';
    $results = $wpdb->get_results($wpdb->prepare("SELECT * FROM " . $wpdb->base_prefix . "%1s" . " where country_id='$csca_default_country' order by name asc", $tbl));
    return $results;
}

function get_states()
{
    global $wpdb;
    $tbl = 'state_pro';
    $results = $wpdb->get_results($wpdb->prepare("SELECT * FROM " . $wpdb->base_prefix . "%1s" . " order by name asc", $tbl));
    return $results;
}

function get_cities()
{
    global $wpdb;
    $tbl = 'city_pro';
    $results = $wpdb->get_results($wpdb->prepare("SELECT * FROM " . $wpdb->base_prefix . "%1s" . " order by name asc", $tbl));
    return $results;
}

function get_cities_by_state_id($sid)
{
    global $wpdb;
    $tbl = 'city_pro';
    $results = $wpdb->get_results($wpdb->prepare("SELECT * FROM " . $wpdb->base_prefix . "%1s" . " where state_id='$sid' order by name asc", $tbl));
    return $results;
}

function get_cities_by_country_id($cid)
{
    global $wpdb;
    $tbl = 'city_pro';
    $tbl1 = 'state_pro';

    $states = $wpdb->get_results($wpdb->prepare("SELECT id FROM " . $wpdb->base_prefix . "%1s" . " where country_id='$cid' order by name asc", $tbl1));

    //$sid=$states[0]['id'];
    foreach ($states as $key => $state) {
        $sid = $state->id;
        $results[] = $wpdb->get_results($wpdb->prepare("SELECT * FROM " . $wpdb->base_prefix . "%1s" . " where state_id='$sid' order by name asc", $tbl));
        //array_merge($results);
    }
    //$results= $wpdb->get_results( $wpdb->prepare( "SELECT * FROM ".$wpdb->base_prefix."%1s"." where state_id IN (".implode(',',$sid).") order by name asc", $tbl) );
    //}
    //$results= $wpdb->get_results( $wpdb->prepare( "SELECT * FROM ".$wpdb->base_prefix."%1s"." where state_id='$sid' order by name asc", $tbl) );
    return $results;
    //return $sid;
}

class CSCA_Submenu
{

    /**
     * A reference the class responsible for rendering the submenu page.
     *
     * @var    Submenu_Page
     * @access private
     */
    private $submenu_page;

    /**
     * Initializes all of the partial classes.
     *
     * @param Submenu_Page $submenu_page A reference to the class that renders the
     *                                                                   page for the plugin.
     */
    public function __construct($submenu_page)
    {
        $this->submenu_page = $submenu_page;
    }

    /**
     * Adds a submenu for this plugin to the 'Tools' menu.
     */
    public function init()
    {
        $licenseKey = get_option("CountryStateCityDropdownPROforContactForm7_lic_Key", "");
        $liceEmail = get_option("CountryStateCityDropdownPROforContactForm7_lic_email", "");
        CountryStateCityDropdownPROforContactForm7Base::addOnDelete(function () {
            delete_option("CountryStateCityDropdownPROforContactForm7_lic_Key");
        });
        if (CountryStateCityDropdownPROforContactForm7Base::CheckWPPlugin($licenseKey, $liceEmail, $this->licenseMessage, $this->responseObj, __FILE__)) {
            add_action('admin_menu', array($this, 'csca_add_menu_page'), 99);
            add_action('admin_menu', array($this, 'csca_add_patch_menu'),99);
        } else {
            add_action('admin_menu', array($this, 'csca_add_menu_page_license'), 99);
        }
    }
    /**
     * Creates the submenu item and calls on the Submenu Page object to render
     * the actual contents of the page.
     */
    public function csca_add_menu_page()
    {
        add_submenu_page('csca_settings', 'CSCA Modify States/Cities', 'Modify States/Cities', 'manage_options', 'add-remove-modify-states-cities', array($this->submenu_page, 'render'));
    }
    public function csca_add_menu_page_license()
    {
        add_submenu_page('csca_settings', 'CSCA Modify States/Cities', 'Modify States/Cities', 'manage_options', 'please-activate-license-csca', array($this, 'activate_request'));
    }
    public function csca_add_patch_menu()
    {
       add_submenu_page('csca_settings','CSCA Patch','CSCA Patch','manage_options','patch-update-new-state-and-cities', array($this->submenu_page, 'patch_setting'));
    }
    
    public function activate_request()
    {
        include_once 'views/activate-request.php';
    }
}

class CSCA_Submenu_Page
{   

    /**
     * This function renders the contents of the page associated with the Submenu
     * that invokes the render method. In the context of this plugin, this is the
     * Submenu class.
     */
    public function render()
    {
        echo "<div class='wrap-main fix-note'>";
        include_once 'views/add-state-form.php';
        include_once 'views/add-city-form.php';
        include_once 'views/remove-state-form.php';
        include_once 'views/remove-city-form.php';
        echo "</div>";
    }

    public function patch_setting()
    {
        include_once 'views/patch-setting.php';
    }
}

class CSCA_Serializer
{

    /**
     * Initializes the function by registering the save function with the
     * admin_post hook so that we can save our options to the database.
     */
    public function init()
    {
        add_action('admin_post', array($this, 'save'));
    }

    /**
     * Validates the incoming nonce value, verifies the current user has
     * permission to save the value from the options page and saves the
     * option to the database.
     */
    public function save()
    {

        // First, validate the nonce and verify the user as permission to save.
        if (!($this->has_valid_nonce() && current_user_can('manage_options'))) {
            // TODO: Display an error message.
        }
        global $wpdb;
        $table_country = $wpdb->prefix . 'countries_pro';
        $table_state = $wpdb->prefix . 'state_pro';
        $table_city = $wpdb->prefix . 'city_pro';
        // If the above are valid, sanitize and save the option.
        if (isset($_POST['csca_new_state'])) {

            if (!empty($value = sanitize_text_field($_POST['csca_new_state'])) && !empty($cntval = sanitize_text_field($_POST['csca_country']))) {

                $results = $wpdb->get_results("SELECT name FROM $table_country WHERE id = '$cntval'");
                if ($results) {
                    //echo "ues";
                    $wpdb->insert($table_state, array("name" => $value, "country_id" => $cntval));
                } else {
                    echo "Country Not Available in Database.";
                }
            }
        }

        if (isset($_POST['csca_new_city'])) {
            $cityval = ($_POST['csca_new_city']);
            $trmctval = explode(",", $cityval);
            //var_dump($tax);
            //die;
            foreach ($trmctval as $trm) {
                //var_dump ($trm);
                // die;
                if (!empty($value = sanitize_text_field($trm)) && !empty($stval = sanitize_text_field($_POST['csca_states']))) {
                    echo $stval;

                    $results = $wpdb->get_results("SELECT name FROM $table_state WHERE id = '$stval'");
                    if ($results) {
                        $wpdb->insert($table_city, array("name" => $value, "state_id" => $stval));
                    } else {
                        echo "State Not Available in Database.";
                    }

                }
            }
        }

        if (isset($_POST['csca_remove_state'])) {

            if (!empty($value = sanitize_text_field($_POST['csca_remove_state'])) && !empty($cntval = sanitize_text_field($_POST['csca_country']))) {
                $results = $wpdb->get_results("SELECT name FROM $table_country WHERE id = '$cntval'");
                if ($results) {
                    $wpdb->get_results("delete FROM $table_state WHERE id = '$value'");
                }

            }
        }
        if (isset($_POST['csca_remove_city'])) {
            if (!empty($value = sanitize_text_field($_POST['csca_remove_city']))) {
                $results = $wpdb->get_results("delete FROM $table_city WHERE id = '$value'");
            }
        }
        $this->redirect();
    }

    /**
     * Determines if the nonce variable associated with the options page is set
     * and is valid.
     *
     * @access private
     *
     * @return boolean False if the field isn't set or the nonce value is invalid;
     *                 otherwise, true.
     */
    private function has_valid_nonce()
    {

        // If the field isn't even in the $_POST, then it's invalid.
        if (!isset($_POST['csca_new_state_nonce'])) { // Input var okay.
            return false;
        }

        $field = wp_unslash($_POST['csca_new_state_nonce']);
        $action = 'csca-settings-save-state';

        return wp_verify_nonce($field, $action);

    }

    /**
     * Redirect to the page from which we came (which should always be the
     * admin page. If the referred isn't set, then we redirect the user to
     * the login page.
     *
     * @access private
     */
    private function redirect()
    {

        // To make the Coding Standards happy, we have to initialize this.
        if (!isset($_POST['_wp_http_referer'])) { // Input var okay.
            $_POST['_wp_http_referer'] = wp_login_url();
        }

        // Sanitize the value of the $_POST collection for the Coding Standards.
        $url = sanitize_text_field(
            wp_unslash($_POST['_wp_http_referer']) // Input var okay.
        );
        // Finally, redirect back to the admin page.
        wp_safe_redirect(urldecode($url));
        exit;

    }
}
