<?php
if ( ! defined( 'ABSPATH' ) ) {
    exit; // Exit if accessed directly
}
/* Include all js and css files */
function tc_pro_csca_embedCssJs()
{
    wp_enqueue_script('tc_pro_csca_country_auto_script', TC_PRO_CSCA_URL . 'assets/js/script.js', array('jquery'));
    include_once TC_PRO_CSCA_PATH . 'includes/updates/csca_base.php';
    $cl = new CSCA_LICENSE_PRO_CF7();
    $licenseKey = get_option("CountryStateCityDropdownPROforContactForm7_lic_Key", "");
    $liceEmail = get_option("CountryStateCityDropdownPROforContactForm7_lic_email", "");
    CountryStateCityDropdownPROforContactForm7Base::addOnDelete(function () {
        delete_option("CountryStateCityDropdownPROforContactForm7_lic_Key");
    });
    if (CountryStateCityDropdownPROforContactForm7Base::CheckWPPlugin($licenseKey, $liceEmail, $cl->licenseMessage, $cl->responseObj, __FILE__)) {
        $data = get_other_csca();
        // var_dump($data);
    } else {
        $data = array("License");
    }
    wp_localize_script('tc_pro_csca_country_auto_script', 'tc_pro_csca_auto_ajax', array('ajax_url' => admin_url('admin-ajax.php'), 'nonce' => wp_create_nonce('tc_pro_csca_ajax_nonce'), 'data' => $data));
    wp_enqueue_style('tc_pro_csca_country_auto_style', TC_PRO_CSCA_URL . 'assets/css/style.css');	
}
add_action('wp_enqueue_scripts', 'tc_pro_csca_embedCssJs');

function get_other_csca()
{
    if (get_option('csca_options')) {
        $other_info = get_option('csca_options');
        $country_id = $other_info['csca_country_field_id'];
        $state_id = $other_info['csca_state_field_id'];
        $city_id = $other_info['csca_city_field_id'];
        $country_place = $other_info['csca_country_placeholder_text_others'];
        $state_place = $other_info['csca_state_placeholder_text_others'];
        $city_place = $other_info['csca_city_placeholder_text_others'];
        $other_state = $other_info['csca_state_other_text_others'];
        $other_city = $other_info['csca_city_other_text_others'];
        if (isset($other_info['csca_select_country_by_IP_others'])) {
            $csca_select_country_by_IP = $other_info['csca_select_country_by_IP_others'];
            if ($csca_select_country_by_IP == '0') {
                $csca_default_country = $other_info['csca_default_country_others'];
            } else if ($csca_select_country_by_IP == '1' || $csca_select_country_by_IP == true) {
                $csca_default_country_name = strtolower(ip_info("Visitor", "Country"));
                //$csca_default_country_name='japan';
                if ($csca_default_country_name) {
                    $cnt = get_countries();
                    foreach ($cnt as $key => $cntr) {
                        $cntr1 = strtolower($cntr->name);
                        if ($cntr1 == $csca_default_country_name) {
                            $csca_default_country = $cntr->id;
                        }
                    }
                } else {
                    $csca_default_country = '0';
                }
            } else {
                $csca_default_country = '0';
            }
        }
        if (isset($other_info['csca_selected_countries_others'])) {
            $csca_selected_countries = $other_info['csca_selected_countries_others'];
            $results['countries'] = get_country_name_by_ids($csca_selected_countries);
        } else {
            $results['countries'] = get_countries();
        }
        //var_dump($csca_selected_countries);

        if ($country_place == '') {
            $country_place = 'Select Your Country';
        }
        if ($state_place == '') {
            $state_place = 'Select Your State';
        }
        if ($city_place == '') {
            $city_place = 'Select Your City';
        }

    } else {
        $country_id = '0';
        $state_id = '0';
        $city_id = '0';
        $country_place = 'Select Country';
        $state_place = 'Select State';
        $city_place = 'Select City';
        $csca_selected_countries = array();

    }

    if ($csca_default_country) {
        $states = get_states_by_country_id($csca_default_country);
    } else {
        $states = array();
    }
    $csca_selected_countries = array();
    if (isset($other_info['csca_selected_countries_others'])) {
        $csca_selected_countries = $other_info['csca_selected_countries_others'];
    }
    $data = array("country_id" => $country_id, "state_id" => $state_id, "city_id" => $city_id, 'country_place' => $country_place, 'state_place' => $state_place, 'city_place' => $city_place, 'other_state' => $other_state, 'other_city' => $other_city, 'select_specific' => $csca_selected_countries, 'default_country' => $csca_default_country);

    return $data;

}
